/****************************************************************************
 *  File: cfuncs.h
 *  Version: 0.4.6c
 *  Sukuna
 *
 *  Created by No22 <gikoforth@s13.xrea.com> on Sun Jul 20 2003.
 *  Copyright (c) 2003,2004,2005,2006,2007 No22. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

DEFCFUNC(c_heap_bl,"heap_blocks",normal_flag,sukuna_heap_blocksw) /* heap_blocks (  -- n )	*/
DEFCFUNC(c_dump,"dump",normal_flag,sukuna_memdumpw)   /* dump		( addr n --  )	*/
DEFCFUNC(c_words,"words",normal_flag,sukuna_words)   /* words	(  --  )	*/
DEFCFUNC(c_errinfo,".errinfo",normal_flag,sukuna_put_error_info)   /* .errinfo (  --  ) */
DEFCFUNC(c_sys_gc,"system_gc",normal_flag,sukuna_gc)   /* system_gc (  --  )	*/
DEFCFUNC(c_gets,"gets",normal_flag,sukuna_getsw)   /* gets		( p n --  )	*/
DEFCFUNC(c_puts,"puts",normal_flag,sukuna_putsw)   /* puts		( p --  )	*/
DEFCFUNC(c_include,"include",normal_flag,sukuna_include_file)   /* include	( "fileName" --  )	*/
DEFCFUNC(c_includep,"(include)",normal_flag,sukuna_includepw)   /* (include)	( addr len --  )	*/
DEFCFUNC(c_save,"save",normal_flag,sukuna_savei)   /* save		( "fileName" --  )	*/
DEFCFUNC(c_getenv,"env$",normal_flag,sukuna_get_env)   /* env$ ( addr n addr' n' -- addr' n' ) */
DEFCFUNC(c_curr_time,"(curr_time)",normal_flag,sukuna_curr_time)   /* (curr_time)		(  -- n )	*/
DEFCFUNC(c_sys_clock,"(sys_clock)",normal_flag,sukuna_sys_clock)   /* (sys_clock)		(  -- n m )	*/
DEFCFUNC(c_rand,"(rand)",normal_flag,sukuna_rand)   /* (rand)		(  -- n )	*/
DEFCFUNC(c_srand,"(srand)",normal_flag,sukuna_srand)   /* (srand)		( seed -- )	*/
DEFCFUNC(c_fopen,"fopen",normal_flag,sukuna_fopenw)   /* fopen ( addr1 n1 addr2 n2 -- fp | nil ) */
DEFCFUNC(c_fclose,"fclose",normal_flag,sukuna_fclosew)   /* fclose ( fp -- nil | eof ) */
DEFCFUNC(c_fgetc,"fgetc",normal_flag,sukuna_fgetcw)   /* fgetc ( fp -- c | eof ) */
DEFCFUNC(c_fgetwc,"fgetwc",normal_flag,sukuna_fgetwcw)   /* fgetwc ( fp -- c | eof ) */
DEFCFUNC(c_fgets,"fgets",normal_flag,sukuna_fgetsw)   /* fgets ( p n fp -- c | eof ) */
DEFCFUNC(c_fputc,"fputc",normal_flag,sukuna_fputcw)   /* fputc ( c fp -- c | eof ) */
DEFCFUNC(c_fputwc,"fputwc",normal_flag,sukuna_fputwcw)   /* fputwc ( c fp -- c | eof ) */
DEFCFUNC(c_fputs,"fputs",normal_flag,sukuna_fputsw)   /* fputs ( p n fp -- n | eof ) */
DEFCFUNC(c_fflush,"fflush",normal_flag,sukuna_fflushw)   /* fflush ( fp -- nil | eof ) */
DEFCFUNC(c_chkvaltyp,"(check_value_type)",normal_flag,sukuna_check_value_typew)   /* (check_value_type) ( value -- type ) */
DEFCFUNC(c_pr_stanno,"(print_stack_annot)",normal_flag,sukuna_print_stack_annotationw)   /* (print_stack_annot) ( addr n p -- ) */
DEFCFUNC(c_setwordargtype,":",normal_flag|immediate_mask,sukuna_set_word_argtypesw)   /* : ( -- ) */
DEFCFUNC(c_setargtype,"-|",normal_flag|immediate_mask,sukuna_set_latest_argtypes)   /* -| ( -- ) */
DEFCFUNC(c_setargtypep,"(set_arg_type)",normal_flag,sukuna_set_argtypes_w)   /* (set_arg_type) ( p -- ) */
DEFCFUNC(c_clntypstk,"(clean_type_stack)",normal_flag,sukuna_clean_type_stackw)   /* (clean_type_stack) ( p -- ) */
DEFCFUNC(c_initypstk,"(init_type_stack)",normal_flag,sukuna_init_type_stack)   /* (init_type_stack) ( -- ) */
DEFCFUNC(c_setlittyp,"(set_lit_type)",normal_flag,sukuna_literal_type_inferencew)   /* (set_lit_type) ( type --  ) */
DEFCFUNC(c_settyplst,"(set_type_list)",normal_flag,sukuna_type_inference_checkw)   /* (set_type_list) ( p --  ) */
DEFCFUNC(c_failtypchk,"(failure_type_check)",normal_flag,sukuna_failure_type_check)   /* (failure_type_check) (  --  ) */
DEFCFUNC(c_newtypeframe,"(new_type_stack_frame)",normal_flag,sukuna_new_type_stack_frame)   /* (new_type_stack_frame) ( -- ) */
DEFCFUNC(c_disposetypeframe,"(dispose_type_stack_frame)",normal_flag,sukuna_dispose_type_stack_frame)   /* (dispose_type_stack_frame) ( -- ) */
DEFCFUNC(c_swaptypeframe,"(swap_type_stack_frame)",normal_flag,sukuna_swap_type_stack_frame)   /* (swap_type_stack_frame) ( -- ) */
DEFCFUNC(c_duptypeframe,"(dup_type_stack_frame)",normal_flag,sukuna_dup_type_stack_frame)   /* (dup_type_stack_frame) ( -- ) */
DEFCFUNC(c_cp_lcfetch,"(compile_local_fetch)",normal_flag,sukuna_compile_localfetchw)
DEFCFUNC(c_cp_mthcall,"(compile_method_call)",normal_flag,sukuna_compile_method_callw)
DEFCFUNC(c_cp_ivfetch,"(compile_ivar_fetch)",normal_flag,sukuna_compile_ivarfetchw)
DEFCFUNC(c_cp_findreqmix,"(find_reqmixin)",normal_flag,sukuna_find_reqmixin_methodw)
DEFCFUNC(c_cp_mthcallinst,"(compile_method_call_inst)",normal_flag,sukuna_compile_method_call_instw)
DEFCFUNC(c_isstlessmix,"statelessmixin?",normal_flag,sukuna_is_stateless_mixinw)
DEFCFUNC(c_print_tname,"(print_type_name)",normal_flag,sukuna_print_class_namew)
DEFCFUNC(c_strmove,"(strmove)",normal_flag,sukuna_strmovew)
DEFCFUNC(c_objtotype,"(>type)",normal_flag,sukuna_obj_to_type)
DEFCFUNC(c_refnumtochar,"$>char",normal_flag,sukuna_numref_to_charw)

