/****************************************************************************
 *  File: primitives.h
 *  Version: 0.4.6c
 *  Sukuna
 *
 *  Created by No22 <gikoforth@s13.xrea.com> on Sun Jul 20 2003.
 *  Copyright (c) 2003,2004,2005,2006,2007 No22. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

DEFINST(_halt,"halt",normal_flag)   /* halt 	(  --  ) 	*/
DEFINST(_exit,"(exit)",normal_flag)   /* (exit)		(  --  )	*/
DEFINST(_noop,"noop",normal_flag)   /* noop		(  --  )	*/
DEFINST(_call,"call",normal_flag)   /* call	( a --  )	*/
DEFINST(_execute,"execute",normal_flag)   /* execute	( a --  )	*/
DEFINST(_branch,"(branch)",normal_flag)   /* (branch)	(  --  )	*/
DEFINST(_fbranch,"(fbranch)",normal_flag)   /* (fbranch)	( b --  )	*/
DEFINST(_jmp1c,"(jmp1c)",normal_flag)   /* (jmp1c) (  --  )	*/
DEFINST(_jump,"(jump)",normal_flag)   /* (jump) ( a  --  )	*/
DEFINST(_abort,"abort",normal_flag)   /* abort ( id --  )	*/
DEFINST(_errorq,"?error",normal_flag)   /* ?error ( b id --  )	*/
DEFINST(_throw,"throw",normal_flag)   /* throw ( e --  )	*/

DEFINST(_dup,"dup",normal_flag)   /* dup		( n -- n n )	*/
DEFINST(_swap,"swap",normal_flag)   /* swap		( a b -- b a )	*/
DEFINST(_drop,"drop",normal_flag)   /* drop		( n --  )	*/
DEFINST(_over,"over",normal_flag)   /* over ( a b -- a b a ) */
DEFINST(_rot,"rot",normal_flag)   /* rot	( a b c -- b c a ) */
DEFINST(_to_r,">r",normal_flag)   /* >r		( n --  )	*/
DEFINST(_from_r,"r>",normal_flag)   /* r>		(  -- n )	*/
DEFINST(_r_drop,"rdrop",normal_flag)   /* rdrop	(  --  )	*/
DEFINST(_r_fetch,"r@",normal_flag)   /* r@		(  -- n )	*/

DEFINST(_1minus,"1-",normal_flag)   /* 1-		( n -- n-1 )	*/
DEFINST(_1plus,"1+",normal_flag)   /* 1+		( n -- n+1 )	*/
DEFINST(_plus,"+",normal_flag)   /* +		( a b -- a+b )	*/
DEFINST(_minus,"-",normal_flag)   /* -		( a b -- a-b )	*/
DEFINST(_times,"*",normal_flag)   /* *		( a b -- a*b )	*/
DEFINST(_divide,"/",normal_flag)   /* /		( a b -- a/b )	*/
DEFINST(_mod,"mod",normal_flag)   /* mod		( a b -- a%b )	*/
DEFINST(_lshift,"lshift",normal_flag)   /* lshift ( n m -- n' )	*/
DEFINST(_rshift,"rshift",normal_flag)   /* rshift ( n m -- n' )	*/

DEFINST(_lteqgt,"<=>",normal_flag)   /* <=>		( a b -- -1 | 0 | 1 )	*/
DEFINST(_eq,"=",normal_flag)   /* =		( a b -- true | false )	*/
DEFINST(_gt,">",normal_flag)   /* >		( a b -- true | false )	*/
DEFINST(_lt,"<",normal_flag)   /* <		( a b -- true | false )	*/
DEFINST(_gteq,">=",normal_flag)   /* >=		( a b -- true | false )	*/
DEFINST(_lteq,"<=",normal_flag)   /* <=		( a b -- true | false )	*/
DEFINST(_neq,"!=",normal_flag)   /* !=		( a b -- true | false )	*/
DEFINST(_niltest,"nil?",normal_flag)   /* nil?		( a -- true | false )	*/
DEFINST(_zeq,"0=",normal_flag)   /* 0=		( a -- true | false )	*/
DEFINST(_b_and,"and",normal_flag)   /* and		( b1 b2 -- b1&b2 )	*/
DEFINST(_b_or,"or",normal_flag)   /* or		( b1 b2 -- b1|b2 )	*/
DEFINST(_b_xor,"xor",normal_flag)   /* xor		( b1 b2 -- b1`xor`b2 )	*/
DEFINST(_b_not,"invert",normal_flag)   /* invert	( b -- invert b )	*/
DEFINST(_l_and,"&",normal_flag)   /* &		( b1 b2 -- true | false )	*/
DEFINST(_l_or,"|",normal_flag)   /* |		( b1 b2 -- true | false )	*/
DEFINST(_l_not,"not",normal_flag)   /* not		( b -- not b )	*/

DEFINST(_strue,"true",normal_flag)   /* true		(  -- true )	*/
DEFINST(_sfalse,"false",normal_flag)   /* false	(  -- false )	*/
DEFINST(_snil,"nil",normal_flag)   /* nil		(  -- nil )	*/
DEFINST(_lit,"(literal)",normal_flag)   /* (literal)	(  -- n )	*/
DEFINST(_lit_at,"(lit@)",normal_flag)   /* (lit@)	(  -- n )	*/

DEFINST(_fetch,"@",normal_flag)   /* @		( p -- n )	*/
DEFINST(_store,"!",normal_flag)   /* !		( n p --  )	*/
DEFINST(_w_fetch,"w@",normal_flag)   /* w@		( p -- w )	*/
DEFINST(_w_store,"w!",normal_flag)   /* w!		( w p --  )	*/

DEFINST(_pstore,"+!",normal_flag)   /* +!	( n addr --  ) */
DEFINST(_gv_inc,"1+!",normal_flag)   /* 1+! ( addr --  )	*/
DEFINST(_gv_dec,"1-!",normal_flag)   /* 1-! ( addr --  )	*/

DEFINST(_cell_plus,"cell+",normal_flag)   /* cell+	( p -- p+cellwidth )	*/
DEFINST(_cell_minus,"cell-",normal_flag)   /* cell-	( p -- p-cellwidth )	*/
DEFINST(_cells_plus,"cells+",normal_flag)   /* cells+	( p n -- p+n*cellwidth )	*/

DEFINST(_sp_fetch,"sp@",normal_flag)   /* sp@		(  -- p )	*/
DEFINST(_sp_store,"sp!",normal_flag)   /* sp!		( p --  )	*/
DEFINST(_rp_fetch,"rp@",normal_flag)   /* rp@		(  -- p )	*/
DEFINST(_rp_store,"rp!",normal_flag)   /* rp!		( p --  )	*/
DEFINST(_cp_fetch,"cp@",normal_flag)   /* cp@	(  -- p )	*/
DEFINST(_cp_store,"cp!",normal_flag)   /* cp!	( p --  )	*/
DEFINST(_dp_fetch,"dp@",normal_flag)   /* dp@	(  -- p )	*/
DEFINST(_dp_store,"dp!",normal_flag)   /* dp!	( p --  )	*/
DEFINST(_tp_fetch,"tp@",normal_flag)   /* tp@	(  -- p )	*/
DEFINST(_tp_store,"tp!",normal_flag)   /* tp!	( p --  )	*/
DEFINST(_lp_fetch,"lp@",normal_flag)   /* lp@ (  -- p )	*/
DEFINST(_lp_store,"lp!",normal_flag)   /* lp! ( p --  )	*/
DEFINST(_op_fetch,"o@",normal_flag)   /* o@	( -- p )	*/
DEFINST(_op_store,"o!",normal_flag)   /* o!	( p -- )	*/
DEFINST(_in_fetch,">in@",normal_flag)   /* >in@	(  -- addr n )	*/
DEFINST(_in_store,">in!",normal_flag)   /* >in!	( addr n --  )	*/
DEFINST(_failcountat,"fc@",normal_flag)   /* fc@ ( -- n ) */
DEFINST(_failcountst,"fc!",normal_flag)   /* fc! ( n -- ) */

DEFINST(_c_base,"code_base",normal_flag)   /* code_base	(  -- addr )	*/
DEFINST(_d_base,"data_base",normal_flag)   /* data_base	(  -- addr )	*/
DEFINST(_t_base,"temp_base",normal_flag)   /* temp_base	(  -- addr )	*/
DEFINST(_s_base,"sp_base",normal_flag)   /* sp_base	(  -- addr )	*/
DEFINST(_r_base,"rp_base",normal_flag)   /* rp_base	(  -- addr )	*/

DEFINST(_p_to_i,"p>i",normal_flag)   /* p>i		( p -- n )	*/
DEFINST(_i_to_p,"i>p",normal_flag)   /* i>p		( n -- p )	*/
DEFINST(_n_to_i,"n>i",normal_flag)   /* n>i		( p -- n )	*/
DEFINST(_i_to_n,"i>n",normal_flag)   /* i>n		( n -- p )	*/
DEFINST(_c_to_i,"c>i",normal_flag)   /* c>i		( c -- n )	*/
DEFINST(_i_to_c,"i>c",normal_flag)   /* i>c		( n -- c )	*/

DEFINST(_intq,"int?",normal_flag)   /* int? ( n -- b )	*/
DEFINST(_ptrq,"ptr?",normal_flag)   /* ptr? ( n -- b )	*/
DEFINST(_charq,"char?",normal_flag)   /* char? ( n -- b )	*/
DEFINST(_symbq,"symb?",normal_flag)   /* symb? ( n -- b )	*/
DEFINST(_vartq,"vart?",normal_flag)   /* vart? ( n -- b )	*/
DEFINST(_check_ptr,"check_ptr",normal_flag)   /* check_ptr ( p -- n ) */

DEFINST(_sstr_to_si,"$>int",normal_flag)   /* $>int ( addr n -- n | nil )	*/
DEFINST(_int_to_sstr,"int>f$",normal_flag)   /* int>f$ ( x addr n addr n -- addr n' )	*/
DEFINST(_cstoss,"cs>ss",normal_flag)   /* cs>ss ( cp sp n -- len ) */
DEFINST(_sstr_cmp,"$<=>",normal_flag)   /* $<=>	( addr n addr' n' -- 0:= -1:< 1:> )	*/
DEFINST(_sstr_cmpi,"$c<=>",normal_flag)   /* $c<=> ( addr n addr' n' -- 0:= -1:< 1:> )	*/

DEFINST(_mem_copy,"mcopy",normal_flag)   /* mcopy ( src dst len --  )	*/
DEFINST(_mem_move,"mmove",normal_flag)   /* mmove ( src dst len --  )	*/

DEFINST(_cr,"cr",normal_flag)   /* cr		(  --  )	*/
DEFINST(_emit,"emit",normal_flag)   /* emit	( c --  ) */
DEFINST(_dot,".",normal_flag)   /* .		( n --  )	*/
DEFINST(_dot_hex,".x",normal_flag)   /* .x		( n --  )	*/
DEFINST(_nemit,".?",normal_flag)   /* .?	( n --  ) */
DEFINST(_type,"type",normal_flag)   /* type	( addr n --  )	*/

DEFINST(_context,"context",normal_flag)   /* context	(  -- addr )	*/
DEFINST(_lc_context,"local_context",normal_flag)   /* local_context (  -- addr )  */

DEFINST(_nextline,"(next_line)",normal_flag)   /* (next_line) ( -- b )  */
DEFINST(_parse_w,"parse_word",normal_flag)   /* parse_word	(  -- addr n )	*/
DEFINST(_parse_ww,"parse-word",normal_flag)   /* parse-word	(  -- addr n )	*/
DEFINST(_find,"find",normal_flag)   /* find	( addr n -- xt | nil )	*/
DEFINST(_skip,"skip",normal_flag)   /* skip	( c --  )	*/
DEFINST(_scan,"scan",normal_flag)   /* scan	( c --  )	*/
DEFINST(_scanw,"scanw",normal_flag)   /* scanw ( c d --  )	*/
DEFINST(_to_xt,">xt",normal_flag)   /* >xt ( xt -- xt' )	*/

DEFINST(_create,"create",normal_flag)   /* create	( "name" --  )	*/
DEFINST(_createp,"(create)",normal_flag)   /* (create)	( addr n --  )	*/
DEFINST(_create_entry,"create_entry",normal_flag)   /* create_entry ( addr len xt --  )	*/

DEFINST(_lcb,"{",normal_flag)   /* {		(  --  )	*/
DEFINST(_rcb,"}",normal_flag|immediate_mask)   /* }		(  --  )	*/
DEFINST(_rcbp,"(})",normal_flag)   /* (})		(  --  )	*/
DEFINST(_immedip,"(immediate)",normal_flag)   /* (immediate) ( -- ) */

DEFINST(_save_dstack,"(save_data_stack)",normal_flag)   /* (save_data_stack) ( x1 .. xn n addr -- )	*/
DEFINST(_load_dstack,"(load_data_stack)",normal_flag)   /* (load_data_stack) ( addr n -- x1 .. xn n )	*/

DEFINST(_lc_entry,"(local_entry)",normal_flag)   /* (local_entry) ( x1 .. xn token: i --  )	*/
DEFINST(_lc_exit,"(local_exit)",normal_flag)   /* (local_exit) ( r: xn .. x1 -- r: )	*/
DEFINST(_dispose_locf,"(dispose_local_frame)",normal_flag)   /* (dispose_local_frame) ( -- ) */
DEFINST(_lc_fetch,"(local_fetch)",normal_flag)   /* (local_fetch) ( token: i -- n )	*/
DEFINST(_lc_store,"(local_store)",normal_flag)   /* (local_store) ( n token: i --  )	*/
DEFINST(_lc_pstore,"(local_pstore)",normal_flag)   /* (local_pstore) ( n token: i --  )	*/
DEFINST(_lc_inc,"(++)",normal_flag)   /* (++) ( token: i --  )	*/
DEFINST(_lc_dec,"(--)",normal_flag)   /* (--) ( token: i --  )	*/
DEFINST(_cp_lstore,"->",normal_flag|immediate_mask)   /* -> ( n s:"name" --  ) */
DEFINST(_cp_lpstore,"+>",normal_flag|immediate_mask)   /* +> ( n s:"name" --  ) */
DEFINST(_cp_lentry,"(compile_locals_entry)",normal_flag)   /* (compile_locals_entry) ( s:" a b : c -- | " --  )	*/
DEFINST(_lc_find,"local_find",normal_flag)   /* local_find	( addr n -- xt | nil )	*/
DEFINST(_add_locv,"(append_lv_entry)",normal_flag)   /* (append_lv_entry)		( addr n m -- )	*/

DEFINST(_lc_fetch1,"(local_fetch1)",normal_flag)   /* (local_fetch1) ( -- n )	*/
DEFINST(_lc_fetch2,"(local_fetch2)",normal_flag)   /* (local_fetch2) ( -- n )	*/
DEFINST(_lc_fetch3,"(local_fetch3)",normal_flag)   /* (local_fetch3) ( -- n )	*/
DEFINST(_lc_fetch4,"(local_fetch4)",normal_flag)   /* (local_fetch4) ( -- n )	*/
DEFINST(_lc_fetch5,"(local_fetch5)",normal_flag)   /* (local_fetch5) ( -- n )	*/
DEFINST(_lc_fetch6,"(local_fetch6)",normal_flag)   /* (local_fetch6) ( -- n )	*/
DEFINST(_lc_fetch7,"(local_fetch7)",normal_flag)   /* (local_fetch7) ( -- n )	*/
DEFINST(_lc_fetch8,"(local_fetch8)",normal_flag)   /* (local_fetch8) ( -- n )	*/

DEFINST(_lbp,"(lb)",normal_flag)   /* (lb)	( token: jumpoffset -- xt ) */
DEFINST(_bl_entry,"(block_entry)",normal_flag)   /* (block_entry)	( token: ^env --  ) */
DEFINST(_bl_exit,"(block_exit)",normal_flag)   /* (block_exit)	(  --  ) */
DEFINST(_gen_blk,"(generate_block)",normal_flag)   /* (generate_block) ( addr --  )	*/
DEFINST(_to_closure,"(to_closure)",normal_flag)   /* (to_closure) ( addr --  )	*/
DEFINST(_lp_lc_store,"(lp_lc_store)",normal_flag)   /* (_lp_lc_store) ( n lp -- ) */

DEFINST(_create_clh,"(create_class_header)",normal_flag)   /* (create_class_header)	( area -- ^class )	*/
DEFINST(_inherit_sup,"(inherit_super)",normal_flag)   /* (inherit_super)	( ^class ^super -- )	*/
DEFINST(_create_vtbl,"(create_vtbl)",normal_flag)   /* (create_vtbl)	( ^class area -- )	*/
DEFINST(_update_vtbl,"(update_vtbl)",normal_flag)   /* (update_vtbl)	( ^class --  )	*/
DEFINST(_create_selr,"(create_selector)",normal_flag)   /* (create_selector)	( -- )	*/
DEFINST(_create_sels,"(selector)",normal_flag)   /* (selector)	( addr n -- )	*/
DEFINST(_create_ivar,"(create_ivar_entry)",normal_flag)   /* (create_ivar_entry)	( ^ivclass addr n ^class offset  --  )	*/
DEFINST(_create_mth,"(create_method_entry)",normal_flag)   /* (create_method_entry)	( -- )	*/
DEFINST(_mth_entry,"(method_entry)",normal_flag)   /* (method_entry) ( ^obj --  ) */
DEFINST(_mth_exit,"(method_exit)",normal_flag)   /* (method_exit) (  --  ) */

DEFINST(_find_method,"(find_method)",normal_flag)   /* (find_method)	( selID ^class -- xta )	*/
DEFINST(_find_self_m,"(find_self_method)",normal_flag)   /* (find_self_method)	( selID ^class -- xta )	*/
DEFINST(_find_ivar,"(find_ivar)",normal_flag)   /* (find_ivar)	( addr n ^class -- xta )	*/
DEFINST(_find_mixin_super,"(find_mixin_super)",normal_flag)   /* (find_mixin_super) ( selID ^mixin -- vofs ^mt )  */
DEFINST(_find_mixin_offs,"(find_mixin_offset)",normal_flag)   /* (find_mixin_offset) ( ^mixin ^class -- offset ) */
DEFINST(_find_super_mth,"(find_super_method)",normal_flag)   /* (find_super_method) ( selID ^class -- xta ) */
DEFINST(_find_superc,"find_super",normal_flag)   /* find_super ( ^keycl ^cl -- b )  */

DEFINST(_selfpp,"(self)",normal_flag)   /* (self) (  -- ^obj ) */
DEFINST(_to_class,">class",normal_flag)   /* >class ( ^obj -- ^class ) */
DEFINST(_to_receiver,">receiver",normal_flag)   /* >receiver	( ^mt ^cl ^ob -- ^ob' )	*/

DEFINST(_invoke_late,"(invoke_late)",normal_flag)   /* (invoke_late) ( ^obj selID -- ) */
DEFINST(_invoke_latei,"(invoke_latei)",normal_flag)   /* (invoke_latei) ( ^obj -- ) */
DEFINST(_invoke_virtual,"(invoke_virtual)",normal_flag)   /* (invoke_virtual)	( ^obj offset --  )	*/
DEFINST(_invoke_virtuali,"(invoke_virtuali)",normal_flag)   /* (invoke_virtuali)	( ^obj --  )	*/
DEFINST(_invoke_mixed_virtual,"(invoke_mixed_virtual)",normal_flag)   /* (invoke_mixed_virtual) ( ^obj selID -- ) */
DEFINST(_invoke_mixed_virtuali,"(invoke_mixed_virtuali)",normal_flag)   /* (invoke_mixed_virtuali) ( ^obj -- ) */
DEFINST(_invoke_mixin,"(invoke_mixin)",normal_flag)   /* (invoke_mixin) ( ^obj ^mx mofs xta -- ) */
DEFINST(_invoke_mixini,"(invoke_mixini)",normal_flag)   /* (invoke_mixini) ( ^obj -- ) */
DEFINST(_invoke_stless_mixin,"(invoke_stless_mixin)",normal_flag)   /* (invoke_stless_mixin) ( ^obj ^mx mofs -- ) */
DEFINST(_invoke_stless_mixini,"(invoke_stless_mixini)",normal_flag)   /* (invoke_stless_mixini) ( ^obj -- ) */
DEFINST(_invoke_force_self,"(invoke_force_self)",normal_flag)   /* (invoke_force_self) ( xta vofs -- ) */
DEFINST(_invoke_force_selfi,"(invoke_force_selfi)",normal_flag)   /* (invoke_force_selfi) ( -- ) */
DEFINST(_invoke_force_class,"(invoke_force_class)",normal_flag)   /* (invoke_force_class) ( ^obj vofs xta -- ) */
DEFINST(_invoke_force_classi,"(invoke_force_classi)",normal_flag)   /* (invoke_force_classi) ( ^obj -- ) */
DEFINST(_invoke_force_mixin,"(invoke_force_mixin)",normal_flag)   /* (invoke_force_mixin) ( ^obj ^mx xta -- ) */
DEFINST(_invoke_force_mixini,"(invoke_force_mixini)",normal_flag)   /* (invoke_force_mixini) ( ^obj -- ) */
DEFINST(_invoke_mixin_super,"(invoke_mixin_super)",normal_flag)   /* (invoke_mixin_super) ( ^obj selID ^mx -- ) */
DEFINST(_invoke_mixin_superi,"(invoke_mixin_superi)",normal_flag)   /* (invoke_mixin_superi) ( ^obj -- ) */
DEFINST(_invoke_static,"(invoke_static)",normal_flag)   /* (invoke_static) ( ^obj xta -- ) */
DEFINST(_invoke_statici,"(invoke_statici)",normal_flag)   /* (invoke_statici) ( ^obj -- ) */

DEFINST(_lit_ivar,"(lit_ivar)",normal_flag)   /* (lit_ivar)	(  -- n )	*/
DEFINST(_to_ivar,"(to_ivar)",normal_flag)   /* (to_ivar)	( n --  )	*/
DEFINST(_lit_mixed_ivar,"(lit_mixed_ivar)",normal_flag)   /* (lit_mixed_ivar)	(  -- n )	*/
DEFINST(_to_mixed_ivar,"(to_mixed_ivar)",normal_flag)   /* (to_p_mixed_ivar)	( n --  )	*/
DEFINST(_to_p_ivar,"(to_p_ivar)",normal_flag)   /* (to_p_ivar)	( n --  )	*/
DEFINST(_to_p_mixed_ivar,"(to_p_mixed_ivar)",normal_flag)   /* (to_p_mixed_ivar)	( n --  )	*/
DEFINST(_to_1p_ivar,"(to_1p_ivar)",normal_flag)   /* (to_1p_ivar)	(  --  )	*/
DEFINST(_to_1m_ivar,"(to_1m_ivar)",normal_flag)   /* (to_1m_ivar)	(  --  )	*/
DEFINST(_to_1p_mixed_ivar,"(to_1p_mixed_ivar)",normal_flag)   /* (to_1p_mixed_ivar)	(  --  )	*/
DEFINST(_to_1m_mixed_ivar,"(to_1m_mixed_ivar)",normal_flag)   /* (to_1m_mixed_ivar)	(  --  )	*/

DEFINST(_f_dot,"f.",normal_flag)   /* F.	( f1 -- )	*/
DEFINST(_f_plus,"f+",normal_flag)   /* F+	( f1 f2 -- f3 )	*/
DEFINST(_f_minus,"f-",normal_flag)   /* F-	( f1 f2 -- f3 )	*/
DEFINST(_f_times,"f*",normal_flag)   /* F*	( f1 f2 -- f3 )	*/
DEFINST(_f_divide,"f/",normal_flag)   /* F/	( f1 f2 -- f3 )	*/
DEFINST(_f_mod,"fmod",normal_flag)   /* Fmod	( f1 f2 -- f3 )	*/
DEFINST(_f_sin,"fsin",normal_flag)   /* Fsin	( f1 -- f3 )	*/
DEFINST(_f_cos,"fcos",normal_flag)   /* Fcos	( f1 -- f3 )	*/
DEFINST(_f_tan,"ftan",normal_flag)   /* Ftan	( f1 -- f3 )	*/
DEFINST(_f_asin,"fasin",normal_flag)   /* Fasin	( f1 -- f3 )	*/
DEFINST(_f_acos,"facos",normal_flag)   /* Facos	( f1 -- f3 )	*/
DEFINST(_f_atan,"fatan",normal_flag)   /* Fatan	( f1 -- f3 )	*/
DEFINST(_f_sinh,"fsinh",normal_flag)   /* Fsinh	( f1 -- f3 )	*/
DEFINST(_f_cosh,"fcosh",normal_flag)   /* Fcosh	( f1 -- f3 )	*/
DEFINST(_f_tanh,"ftanh",normal_flag)   /* Ftanh	( f1 -- f3 )	*/
DEFINST(_f_atan2,"fatan2",normal_flag)   /* Fatan2	( f1 f2 -- f3 )	*/
DEFINST(_f_exp,"fexp",normal_flag)   /* Fexp		( f1 -- f3 )	*/
DEFINST(_f_ln,"fln",normal_flag)   /* Fln		( f1 -- f3 )	*/
DEFINST(_f_log,"flog",normal_flag)   /* Flog		( f1 -- f3 )	*/
DEFINST(_f_pow,"f^",normal_flag)   /* f^		( f1 f2 -- f3 )	*/
DEFINST(_f_sqrt,"fsqrt",normal_flag)   /* fsqrt	( f1 -- f3 )	*/
DEFINST(_f_ceil,"fceil",normal_flag)   /* fceil	( f1 -- f3 )	*/
DEFINST(_f_floor,"ffloor",normal_flag)   /* ffloor	( f1 -- f3 )	*/
DEFINST(_f_abs,"fabs",normal_flag)   /* fabs		( f1 -- f3 )	*/
DEFINST(_f_lteqgt,"f<=>",normal_flag)   /* f<=>		( f1 f2 -- b )	*/
DEFINST(_f_ameq,"f~~",normal_flag)   /* f~~		( f1 f2 e -- b )	*/
DEFINST(_f_apeq,"f=~",normal_flag)   /* f=~		( f1 f2 e -- b )	*/
DEFINST(_f_negate,"fnegate",normal_flag)   /* fnegate	( f1 -- f3 )	*/
DEFINST(_f_to_i,"f>i",normal_flag)   /* f>i		( f1 -- f3 )	*/
DEFINST(_i_to_f,"i>f",normal_flag)   /* i>f		( f1 -- f3 )	*/
DEFINST(_f_to_sstr,"f>f$",normal_flag)   /* f>f$		( f1 addr n -- addr n' )	*/
DEFINST(_sstr_to_f,"$>f",normal_flag)   /* $>f		( addr n -- f1 )	*/

DEFINST(_alloc,"allocate",normal_flag)   /* allocate ( size -- p )	*/
DEFINST(_free,"free",normal_flag)   /* free ( p --  )	*/

DEFINST(_eval,"evaluate",normal_flag)   /* evaluate ( addr len --  )	*/
DEFINST(_evalcont,"(evalcont)",normal_flag)   /* 	*/

DEFINST(_poptostype,"(pop_tos_type)",normal_flag)   /* (pop_tos_type) (  -- p ) */
DEFINST(_pushtostype,"(push_tos_type)",normal_flag)   /* (push_tos_type) ( p -- ) */
DEFINST(_popargtype,"(pop_arg_type)",normal_flag)   /* (pop_arg_type) (  -- p ) */
DEFINST(_pushargtype,"(push_arg_type)",normal_flag)   /* (push_arg_type) ( p -- ) */

DEFINST(_cfunci,"(cfunci)",normal_flag)   /* (cfunci) ( .. -- .. ) */

DEFINST(_bye,"bye",normal_flag)   /* bye		(  --  )	*/
